/**
 * T-Messenger
 * THIS IS NOT FREE SOFTWARE, DO NOT DISTRIBUTE.
 *
 * @summary Real-time Text parser, optimized for performance
 * @dependecy TM.locale, TM.settings, TM.string, TM.services.bitly
 * @author Andres Pagella (fokker@alkon.com.ar)
 */

var TM;
if (!TM) TM = {};

if (!TM.parser) TM.parser = {};

/**
 * TM.parser.parse
 * @summary Parses the text and shrinks URLs
 * @param object input text / textbox
 * @return void
 */
TM.parser.parse = function(objectID)
{
	text = objectID.value.split(" ");

	if (text.length > 0) {
		for (i = 0; i < text.length; i++) {
			if (TM.string.isUrl(text[i])) {
				if (text[i].length > 22 && 
					text[i].search('/bit\.ly/') == -1 && // Don't shorten already shortened URLs
					text[i].search('/twitpic\.com/') == -1) { // Don't shorten Twitpic URLs
					//shortenedURL = TM.services.bitly.shorten(text[i]);
					TM.services.bitly.shorten(objectID, text[i]); // Shorten URL if possible.
					//objectID.value.replace(text[i], shortenedURL);
				}
			}
		}
	}
}

/**
 * TM.parser.count
 * @summary Parses the text and shrinks URLs
 * @param object sourceID The source textbox
 * @param string screen_name (optional) 
 * @return integer with the number of characters left
 */
TM.parser.count_chars = function(sourceID, screen_name)
{
	if (screen_name == undefined) {
		var screen_name = '';
	}
	
	var sourceText = sourceID.value;
	
	return (sourceText.length != 0) ? ((140 - parseInt(screen_name.length)) - sourceText.length) : 140;
}
